"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Compilation = exports.CompilationOptions = void 0;

var _core = require("@syndicate-lang/core");

var _job = require("./job");

var _Syndicate = require("@syndicate-lang/core");

var _Dataspace = _Syndicate.Dataspace;
var _Skeleton = _Syndicate.Skeleton;
var _Record = _Syndicate.Record;
var _savedGlobalFacet = _Dataspace._currentFacet;
_Dataspace._currentFacet = new _Syndicate._Dataspace.ActionCollector();

require("@syndicate-lang/syntax/lib/index"); // patches babel -- load before any of babel loads!!


var BabelTransform = require("@babel/core/lib/transform");

var CompilationOptions = _Record.makeBasicConstructor(Symbol["for"]("CompilationOptions"), ["options"]);

exports.CompilationOptions = CompilationOptions;

var Compilation = _Record.makeBasicConstructor(Symbol["for"]("Compilation"), ["filename", "input"]);

exports.Compilation = Compilation;

_Dataspace.spawn('compiler', function () {
  var worker = (0, _core.genUuid)('worker');
  {
    var _facets2 = _Syndicate.Map();

    _Dataspace._currentFacet.addEndpoint(function () {
      var _assn = _Syndicate.Observe((0, _core.Inbound)(CompilationOptions(_Syndicate.Capture(_Syndicate.Discard._instance))));

      var _handler = {
        skeleton: [_core.Inbound.constructorInfo, [CompilationOptions.constructorInfo, null]],
        constPaths: _Syndicate.fromJS([]),
        constVals: _Syndicate.fromJS([]),
        capturePaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0])]),
        assertion: _assn,
        callback: _Dataspace.wrap(function (_evt, _vs) {
          if (_evt === _Skeleton.EVENT_ADDED) {
            var _options = _vs.get(0);

            _Dataspace._currentFacet.actor.scheduleScript(function () {
              _Dataspace._currentFacet.actor.addFacet(_Dataspace._currentFacet, function () {
                _facets2 = _facets2.set(_Syndicate.fromJS([_options]), _Dataspace._currentFacet);

                _Dataspace._currentFacet.addDataflow(function () {
                  void 0;
                });

                {
                  {
                    var _facets4 = _Syndicate.Map();

                    _Dataspace._currentFacet.addEndpoint(function () {
                      var _c5 = worker;

                      var _assn2 = _Syndicate.Observe((0, _core.Inbound)((0, _core.Observe)((0, _job.WorkItem)(_c5, Compilation(_Syndicate.Capture(_Syndicate.Discard._instance), _Syndicate.Capture(_Syndicate.Discard._instance)), _Syndicate.Discard._instance))));

                      var _handler2 = {
                        skeleton: [_core.Inbound.constructorInfo, [_core.Observe.constructorInfo, [_job.WorkItem.constructorInfo, null, [Compilation.constructorInfo, null, null], null]]],
                        constPaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0, 0])]),
                        constVals: _Syndicate.fromJS([_c5]),
                        capturePaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0, 1, 0]), _Syndicate.fromJS([0, 0, 1, 1])]),
                        assertion: _assn2,
                        callback: _Dataspace.wrap(function (_evt2, _vs2) {
                          if (_evt2 === _Skeleton.EVENT_ADDED) {
                            var _filename = _vs2.get(0);

                            var _input = _vs2.get(1);

                            _Dataspace._currentFacet.actor.scheduleScript(function () {
                              _Dataspace._currentFacet.actor.addFacet(_Dataspace._currentFacet, function () {
                                _facets4 = _facets4.set(_Syndicate.fromJS([_filename, _input]), _Dataspace._currentFacet);

                                _Dataspace._currentFacet.addDataflow(function () {
                                  void 0;
                                });

                                {
                                  var finalOptions = Object.assign({
                                    filename: '/' + _filename
                                  }, _options.toJS());
                                  console.log(worker, 'compiling', _filename);
                                  BabelTransform.transform(_input, finalOptions, _core.Dataspace.wrapExternal(function (err, output) {
                                    _Dataspace._currentFacet.actor.addFacet(_Dataspace._currentFacet, function () {
                                      _Dataspace._currentFacet.addEndpoint(function () {
                                        return [(0, _core.Outbound)((0, _job.WorkItem)(worker, Compilation(_filename, _input), err ? (0, _job.JobError)(err.toString()) : (0, _job.JobResult)(output.code))), null];
                                      }, true);
                                    }, true);
                                  }));
                                }
                              }, true);
                            });
                          }
                        })
                      };
                      return [_assn2, _handler2];
                    }, true);

                    _Dataspace._currentFacet.addEndpoint(function () {
                      var _c6 = worker;

                      var _assn3 = _Syndicate.Observe((0, _core.Inbound)((0, _core.Observe)((0, _job.WorkItem)(_c6, Compilation(_Syndicate.Capture(_Syndicate.Discard._instance), _Syndicate.Capture(_Syndicate.Discard._instance)), _Syndicate.Discard._instance))));

                      var _handler3 = {
                        skeleton: [_core.Inbound.constructorInfo, [_core.Observe.constructorInfo, [_job.WorkItem.constructorInfo, null, [Compilation.constructorInfo, null, null], null]]],
                        constPaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0, 0])]),
                        constVals: _Syndicate.fromJS([_c6]),
                        capturePaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0, 1, 0]), _Syndicate.fromJS([0, 0, 1, 1])]),
                        assertion: _assn3,
                        callback: _Dataspace.wrap(function (_evt3, _vs3) {
                          if (_evt3 === _Skeleton.EVENT_REMOVED) {
                            var _filename2 = _vs3.get(0);

                            var _input2 = _vs3.get(1);

                            _Dataspace._currentFacet.actor.scheduleScript(function () {
                              {
                                var _key3 = _Syndicate.fromJS([_filename2, _input2]);

                                _facets4.get(_key3).stop();

                                _facets4 = _facets4.remove(_key3);
                              }
                            });
                          }
                        })
                      };
                      return [_assn3, _handler3];
                    }, true);
                  }
                }
              }, true);
            });
          }
        })
      };
      return [_assn, _handler];
    }, true);

    _Dataspace._currentFacet.addEndpoint(function () {
      var _assn4 = _Syndicate.Observe((0, _core.Inbound)(CompilationOptions(_Syndicate.Capture(_Syndicate.Discard._instance))));

      var _handler4 = {
        skeleton: [_core.Inbound.constructorInfo, [CompilationOptions.constructorInfo, null]],
        constPaths: _Syndicate.fromJS([]),
        constVals: _Syndicate.fromJS([]),
        capturePaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0])]),
        assertion: _assn4,
        callback: _Dataspace.wrap(function (_evt4, _vs4) {
          if (_evt4 === _Skeleton.EVENT_REMOVED) {
            var _options2 = _vs4.get(0);

            _Dataspace._currentFacet.actor.scheduleScript(function () {
              {
                var _key4 = _Syndicate.fromJS([_options2]);

                _facets2.get(_key4).stop();

                _facets2 = _facets2.remove(_key4);
              }
            });
          }
        })
      };
      return [_assn4, _handler4];
    }, true);
  }
});

module.exports[_Dataspace.BootSteps] = {
  module: module,
  steps: _Dataspace._currentFacet.actions
};
_Dataspace._currentFacet = _savedGlobalFacet;
_savedGlobalFacet = null;

if ((typeof require === 'undefined' ? {
  main: void 0
} : require).main === module) {
  _Syndicate.bootModule(module);
}

