"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JobError = exports.JobResult = exports.Job = exports.WorkItem = void 0;

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var _Syndicate = require("@syndicate-lang/core");

var _Dataspace = _Syndicate.Dataspace;
var _Skeleton = _Syndicate.Skeleton;
var _Record = _Syndicate.Record;
var _savedGlobalFacet = _Dataspace._currentFacet;
_Dataspace._currentFacet = new _Syndicate._Dataspace.ActionCollector();

var _require = require("@syndicate-lang/core"),
    currentFacet = _require.currentFacet,
    Observe = _require.Observe,
    List = _require.List,
    Map = _require.Map,
    Set = _require.Set,
    Skeleton = _require.Skeleton;

var WorkItem = _Record.makeBasicConstructor(Symbol["for"]("WorkItem"), ["worker", "item", "result"]);

exports.WorkItem = WorkItem;

var Job = _Record.makeBasicConstructor(Symbol["for"]("Job"), ["item", "result"]);

exports.Job = Job;

var JobResult = _Record.makeBasicConstructor(Symbol["for"]("JobResult"), ["output"]);

exports.JobResult = JobResult;

var JobError = _Record.makeBasicConstructor(Symbol["for"]("JobError"), ["err"]);

exports.JobError = JobError;

_Dataspace.spawn('JobDispatcher', function () {
  var _this = this;

  _Dataspace.declareField(this, "readyWorkers", Map()); // Pattern -> Set(WorkerId)


  _Dataspace.declareField(this, "runningJobs", 0); // dataflow console.log(this.runningJobs + ' runningJobs; readyWorkers: ' + this.readyWorkers);


  {
    var _facets2 = _Syndicate.Map();

    _Dataspace._currentFacet.addEndpoint(function () {
      var _assn = _Syndicate.Observe(Observe(Observe(WorkItem(_Syndicate.Capture(_Syndicate.Discard._instance), _Syndicate.Capture(_Syndicate.Discard._instance), _Syndicate.Discard._instance))));

      var _handler = {
        skeleton: [Observe.constructorInfo, [Observe.constructorInfo, [WorkItem.constructorInfo, null, null, null]]],
        constPaths: _Syndicate.fromJS([]),
        constVals: _Syndicate.fromJS([]),
        capturePaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0, 0]), _Syndicate.fromJS([0, 0, 1])]),
        assertion: _assn,
        callback: _Dataspace.wrap(function (_evt, _vs) {
          if (_evt === _Skeleton.EVENT_ADDED) {
            var _worker = _vs.get(0);

            var _pattern = _vs.get(1);

            _Dataspace._currentFacet.actor.scheduleScript(function () {
              _Dataspace._currentFacet.actor.addFacet(_Dataspace._currentFacet, function () {
                _facets2 = _facets2.set(_Syndicate.fromJS([_worker, _pattern]), _Dataspace._currentFacet);

                _Dataspace._currentFacet.addDataflow(function () {
                  void 0;
                });

                {
                  if (!Skeleton.isCompletelyConcrete(_pattern)) {
                    var p = Skeleton.withoutCaptures(_pattern);

                    _Dataspace._currentFacet.addStartScript(function () {
                      addWorker(p, _worker);
                    });

                    _Dataspace._currentFacet.addStopScript(function () {
                      removeWorker(p, _worker);
                    });
                  }
                }
              }, true);
            });
          }
        })
      };
      return [_assn, _handler];
    }, true);

    _Dataspace._currentFacet.addEndpoint(function () {
      var _assn2 = _Syndicate.Observe(Observe(Observe(WorkItem(_Syndicate.Capture(_Syndicate.Discard._instance), _Syndicate.Capture(_Syndicate.Discard._instance), _Syndicate.Discard._instance))));

      var _handler2 = {
        skeleton: [Observe.constructorInfo, [Observe.constructorInfo, [WorkItem.constructorInfo, null, null, null]]],
        constPaths: _Syndicate.fromJS([]),
        constVals: _Syndicate.fromJS([]),
        capturePaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0, 0]), _Syndicate.fromJS([0, 0, 1])]),
        assertion: _assn2,
        callback: _Dataspace.wrap(function (_evt2, _vs2) {
          if (_evt2 === _Skeleton.EVENT_REMOVED) {
            var _worker2 = _vs2.get(0);

            var _pattern2 = _vs2.get(1);

            _Dataspace._currentFacet.actor.scheduleScript(function () {
              {
                var _key2 = _Syndicate.fromJS([_worker2, _pattern2]);

                _facets2.get(_key2).stop();

                _facets2 = _facets2.remove(_key2);
              }
            });
          }
        })
      };
      return [_assn2, _handler2];
    }, true);
  } // TODO: reuse the dataspace's index somehow to get a more efficient
  // job-dispatcher? Once quoting issues are solved, something like
  //
  // during Observe(Observe(WorkItem(_, $pattern, _))) {
  //   field this.readyWorkers = Set();
  //   during Observe(Observe(WorkItem($worker, pattern, _))) { ... }
  //   during Observe(Job(fixquoting(pattern), _)) { ... }
  // }

  var addWorker = function addWorker(pattern, worker) {
    var rw = _this.readyWorkers;
    _this.readyWorkers = rw.set(pattern, rw.get(pattern, Set()).add(worker));
  };

  var removeWorker = function removeWorker(pattern, worker) {
    var rw = _this.readyWorkers;
    var ws = rw.get(pattern, Set()).remove(worker);

    if (ws.isEmpty()) {
      _this.readyWorkers = rw.remove(pattern);
    } else {
      _this.readyWorkers = rw.set(pattern, ws);
    }
  };

  var findWorkerSet = function findWorkerSet(item) {
    var matches = _this.readyWorkers.filter(function (ids, pat) {
      return Skeleton.match(pat, item) !== false;
    });

    switch (matches.size) {
      case 0:
        return [null, Set()];

      default:
        console.error('Multiple workers claiming job', item, List(matches.keys()));

      /* FALL THROUGH */

      case 1:
        return matches.entries().next().value;
    }
  };

  {
    var _facets4 = _Syndicate.Map();

    _Dataspace._currentFacet.addEndpoint(function () {
      var _assn3 = _Syndicate.Observe(Observe(Job(_Syndicate.Capture(_Syndicate.Discard._instance), _Syndicate.Discard._instance)));

      var _handler3 = {
        skeleton: [Observe.constructorInfo, [Job.constructorInfo, null, null]],
        constPaths: _Syndicate.fromJS([]),
        constVals: _Syndicate.fromJS([]),
        capturePaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0])]),
        assertion: _assn3,
        callback: _Dataspace.wrap(function (_evt3, _vs3) {
          if (_evt3 === _Skeleton.EVENT_ADDED) {
            var _item = _vs3.get(0);

            _Dataspace._currentFacet.actor.scheduleScript(function () {
              _Dataspace._currentFacet.actor.addFacet(_Dataspace._currentFacet, function () {
                var _this2 = this;

                _facets4 = _facets4.set(_Syndicate.fromJS([_item]), _Dataspace._currentFacet);

                _Dataspace._currentFacet.addDataflow(function () {
                  void 0;
                });

                {
                  _Dataspace._currentFacet.addStartScript(function () {
                    _this2.runningJobs++;
                  });

                  _Dataspace._currentFacet.addStopScript(function () {
                    this.runningJobs--;
                  });

                  var waitForWorker = function waitForWorker(retryCount) {
                    if (retryCount === 3) {
                      console.error('Failed job, too many retries', _item);

                      _Dataspace._currentFacet.actor.addFacet(_Dataspace._currentFacet, function () {
                        _Dataspace._currentFacet.addEndpoint(function () {
                          return [Job(_item, JobError(new Error("Too many retries"))), null];
                        }, true);
                      }, true);
                    } else {
                      _Dataspace._currentFacet.actor.addFacet(_Dataspace._currentFacet, function () {
                        var facet = currentFacet();

                        _Dataspace._currentFacet.addDataflow(function () {
                          {
                            var _findWorkerSet = findWorkerSet(_item),
                                _findWorkerSet2 = _slicedToArray(_findWorkerSet, 2),
                                itemPattern = _findWorkerSet2[0],
                                workers = _findWorkerSet2[1];

                            if (!workers.isEmpty()) {
                              var _worker3 = workers.first();

                              removeWorker(itemPattern, _worker3);
                              facet.stop(function () {
                                _Dataspace._currentFacet.actor.addFacet(_Dataspace._currentFacet, function () {
                                  _Dataspace._currentFacet.addEndpoint(function () {
                                    var _c4 = _worker3;

                                    var _assn4 = _Syndicate.Observe(Observe(Observe(WorkItem(_c4, _Syndicate.Discard._instance, _Syndicate.Discard._instance))));

                                    var _handler4 = {
                                      skeleton: [Observe.constructorInfo, [Observe.constructorInfo, [WorkItem.constructorInfo, null, null, null]]],
                                      constPaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0, 0])]),
                                      constVals: _Syndicate.fromJS([_c4]),
                                      capturePaths: _Syndicate.fromJS([]),
                                      assertion: _assn4,
                                      callback: _Dataspace.wrap(function (_evt4, _vs4) {
                                        if (_evt4 === _Skeleton.EVENT_REMOVED) {
                                          _Dataspace._currentFacet.actor.scheduleScript(function () {
                                            _Dataspace._currentFacet.stop(function () {
                                              {
                                                console.warn('Worker withdrew before answering', _worker3);
                                                waitForWorker(retryCount + 1);
                                              }
                                            });
                                          });
                                        }
                                      })
                                    };
                                    return [_assn4, _handler4];
                                  }, true);

                                  _Dataspace._currentFacet.addEndpoint(function () {
                                    var _c5 = _worker3;
                                    var _c6 = _item;

                                    var _assn5 = _Syndicate.Observe(WorkItem(_c5, _c6, _Syndicate.Capture(_Syndicate.Discard._instance)));

                                    var _handler5 = {
                                      skeleton: [WorkItem.constructorInfo, null, null, null],
                                      constPaths: _Syndicate.fromJS([_Syndicate.fromJS([0]), _Syndicate.fromJS([1])]),
                                      constVals: _Syndicate.fromJS([_c5, _c6]),
                                      capturePaths: _Syndicate.fromJS([_Syndicate.fromJS([2])]),
                                      assertion: _assn5,
                                      callback: _Dataspace.wrap(function (_evt5, _vs5) {
                                        if (_evt5 === _Skeleton.EVENT_ADDED) {
                                          var _result = _vs5.get(0);

                                          _Dataspace._currentFacet.actor.scheduleScript(function () {
                                            _Dataspace._currentFacet.stop(function () {
                                              {
                                                addWorker(itemPattern, _worker3);

                                                _Dataspace._currentFacet.actor.addFacet(_Dataspace._currentFacet, function () {
                                                  _Dataspace._currentFacet.addEndpoint(function () {
                                                    return [Job(_item, _result), null];
                                                  }, true);
                                                }, true);
                                              }
                                            });
                                          });
                                        }
                                      })
                                    };
                                    return [_assn5, _handler5];
                                  }, true);
                                }, true);
                              });
                            }
                          }
                        });
                      }, true);
                    }
                  };

                  _Dataspace._currentFacet.addStartScript(function () {
                    waitForWorker(0);
                  });
                }
              }, true);
            });
          }
        })
      };
      return [_assn3, _handler3];
    }, true);

    _Dataspace._currentFacet.addEndpoint(function () {
      var _assn6 = _Syndicate.Observe(Observe(Job(_Syndicate.Capture(_Syndicate.Discard._instance), _Syndicate.Discard._instance)));

      var _handler6 = {
        skeleton: [Observe.constructorInfo, [Job.constructorInfo, null, null]],
        constPaths: _Syndicate.fromJS([]),
        constVals: _Syndicate.fromJS([]),
        capturePaths: _Syndicate.fromJS([_Syndicate.fromJS([0, 0])]),
        assertion: _assn6,
        callback: _Dataspace.wrap(function (_evt6, _vs6) {
          if (_evt6 === _Skeleton.EVENT_REMOVED) {
            var _item2 = _vs6.get(0);

            _Dataspace._currentFacet.actor.scheduleScript(function () {
              {
                var _key4 = _Syndicate.fromJS([_item2]);

                _facets4.get(_key4).stop();

                _facets4 = _facets4.remove(_key4);
              }
            });
          }
        })
      };
      return [_assn6, _handler6];
    }, true);
  }
});

module.exports[_Dataspace.BootSteps] = {
  module: module,
  steps: _Dataspace._currentFacet.actions
};
_Dataspace._currentFacet = _savedGlobalFacet;
_savedGlobalFacet = null;

if ((typeof require === 'undefined' ? {
  main: void 0
} : require).main === module) {
  _Syndicate.bootModule(module);
}

